"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});
var compareEvents = function compareEvents(a, b) {
    return a.timestamp - b.timestamp;
};

function createDriver(_ref) {
    var events = _ref.events;

    var store = events || [];

    return {
        saveEvent: function saveEvent(event) {
            store.push(event);
            return Promise.resolve();
        },

        loadEventsByTypes: function loadEventsByTypes(types, callback) {
            return Promise.resolve(store.filter(function (event) {
                return types.includes(event.type);
            }).sort(compareEvents).forEach(callback));
        },

        loadEventsByAggregateId: function loadEventsByAggregateId(ids, callback) {
            return Promise.resolve(store.filter(function (event) {
                return ids.includes(event.aggregateId);
            }).sort(compareEvents).forEach(callback));
        }
    };
}

exports.default = createDriver;
module.exports = exports["default"];